Đến nội dung


Hình ảnh
- - - - -

Vấn đề vát mép trong Autolisp


  • Please log in to reply
9 replies to this topic

#1 haihau81

haihau81

    Chưa sử dụng CAD

  • Members
  • Pip
  • 4 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 08 July 2009 - 04:20 PM

Mình muốn vát mép các góc trên bản vẽ khi lập trình autolisp nhưng không biết phải làm sao:
VD: Đây là đoạn mã vẽ hình chữ nhật:

(defun c:HCN (/ HCN1 HCN2)
(setq HCN1 (getpoint "\ cho diem bat dau ve: ")
HCN2 (list (+ (car HCN1) 100) (+ (cadr HCN1) 50))
)
(command "rectang" HCN1 HCN2)
)

Mình muốn viết thêm để có thể vát mép 4 góc hình chữ nhật này. Sau khi đoạn mã hoàn chỉnh có thể gọi lệnh HCN là được 1 hình chữ nhật vát mép 4 góc. Điều này có thể thực hiện được ko. Nếu được nhờ anh em giúp hộ cái.
  • 0

#2 duy782006

duy782006

    PHẠM QUỐC DUY

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 2155 Bài viết
Điểm đánh giá: 1360 (rất tốt)

Đã gửi 08 July 2009 - 04:34 PM

Mình muốn vát mép các góc trên bản vẽ khi lập trình autolisp nhưng không biết phải làm sao:
VD: Đây là đoạn mã vẽ hình chữ nhật:

(defun c:HCN (/ HCN1 HCN2)
(setq HCN1 (getpoint "\ cho diem bat dau ve: ")
HCN2 (list (+ (car HCN1) 100) (+ (cadr HCN1) 50))
)
(command "rectang" HCN1 HCN2)
)

Mình muốn viết thêm để có thể vát mép 4 góc hình chữ nhật này. Sau khi đoạn mã hoàn chỉnh có thể gọi lệnh HCN là được 1 hình chữ nhật vát mép 4 góc. Điều này có thể thực hiện được ko. Nếu được nhờ anh em giúp hộ cái.

Có hai cách để làm việc này:
-Vẽ hình chử nhật. dùng lệnh fillet định bán kính, chon tham số P (poliline), chọn đối tượng là hình chử nhật vùa vẽ "last"
-Vẽ hình chử nhật với tham số F (fillet). Cách này ảnh hưởng đến lệnh rec sau này muốn nó không bo góc thì phải định lại tham số f.


(setq a (getpoint "\nDiem thu nhat: "))
(setq b (getcorner a"\nDiem thu hai: "))
(command "rectangle" (list (car a) (cadr a)) (list (car B) (cadr B)))
(command "fillet" "radius" 200)
(command "fillet" "polyline" "last" "")

  • 1

Cứ ngỡ trần gian là cõi thật.Cho nên tất bật đến bây giờ.
Tạo hộp thoại bằng lisp My blog QUY ĐỊNH ĐẶT TÊN TOPIC TRONG CHUYÊN MỤC LISPD http://ktsduy.wordpress.com/
Để cám ơn chỉ cần nhấn rep_up.png
(Là nhấn vào nút đó phía bài viết của người ta í chứ đừng có nhè cái hình này mà nhấn miết đi nha :-D


#3 haihau81

haihau81

    Chưa sử dụng CAD

  • Members
  • Pip
  • 4 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 08 July 2009 - 04:45 PM

Có hai cách để làm việc này:
-Vẽ hình chử nhật. dùng lệnh fillet định bán kính, chon tham số P (poliline), chọn đối tượng là hình chử nhật vùa vẽ "last"
-Vẽ hình chử nhật với tham số F (fillet). Cách này ảnh hưởng đến lệnh rec sau này muốn nó không bo góc thì phải định lại tham số f.

Đây là mình vd TH điển hình nếu la nhiều góc do các line tao thành thì sao?
VD:

(defun c:goc (/ D1 D2 D3)
(setq D1 (getpoint "\ cho diem bat dau ve: ")
D2 (list (car D1) (+ (cadr D1) 50))
D3 (list (+ (car D2) 100) (cadr D2))
)
(command "line" D1 D2 D3 "")
)

Đây là đoạn mã vẽ 1 góc được tạo thành bởi 2 dường line mình muốn lập trình vát mép góc này thì phải làm sao?
  • 0

#4 duy782006

duy782006

    PHẠM QUỐC DUY

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 2155 Bài viết
Điểm đánh giá: 1360 (rất tốt)

Đã gửi 08 July 2009 - 04:48 PM

Đây là mình vd TH điển hình nếu la nhiều góc do các line tao thành thì sao?

Đây là đoạn mã vẽ 1 góc được tạo thành bởi 2 dường line mình muốn lập trình vát mép góc này thì phải làm sao?

Vì bạn mới tham gia nên mình nhắc bạn trong yêu cầu và hỏi về lisp không nên thay đổi câu hỏi với câu làhồi nảy chỉ là ví dụ. Vì với 1 yêu cầu nhứt định với 1 loại đối tượng nhất định thì cách xử lí là khác nhau.
  • 0

Cứ ngỡ trần gian là cõi thật.Cho nên tất bật đến bây giờ.
Tạo hộp thoại bằng lisp My blog QUY ĐỊNH ĐẶT TÊN TOPIC TRONG CHUYÊN MỤC LISPD http://ktsduy.wordpress.com/
Để cám ơn chỉ cần nhấn rep_up.png
(Là nhấn vào nút đó phía bài viết của người ta í chứ đừng có nhè cái hình này mà nhấn miết đi nha :-D


#5 haihau81

haihau81

    Chưa sử dụng CAD

  • Members
  • Pip
  • 4 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 08 July 2009 - 04:53 PM

ah` mình hiểu cách xử lý rồi cảm ơn bạn nhiều nha
  • 0

#6 Tue_NV

Tue_NV

    KS Võ Quang Tuệ

  • Moderator
  • PipPipPipPipPipPipPip
  • 4296 Bài viết
Điểm đánh giá: 3804 (đỉnh cao)

Đã gửi 08 July 2009 - 05:00 PM

Có hai cách để làm việc này:
-Vẽ hình chử nhật. dùng lệnh fillet định bán kính, chon tham số P (poliline), chọn đối tượng là hình chử nhật vùa vẽ "last"
-Vẽ hình chử nhật với tham số F (fillet). Cách này ảnh hưởng đến lệnh rec sau này muốn nó không bo góc thì phải định lại tham số f.
(setq a (getpoint "\nDiem thu nhat: "))
(setq b (getcorner a"\nDiem thu hai: "))
(command "rectangle" (list (car a) (cadr a)) (list (car :blink: (cadr :s_big:))
(command "fillet" "radius" 200)
(command "fillet" "polyline" "last" "")


Mình muốn vát mép các góc trên bản vẽ khi lập trình autolisp nhưng không biết phải làm sao:
Mình muốn viết thêm để có thể vát mép 4 góc hình chữ nhật này. Sau khi đoạn mã hoàn chỉnh có thể gọi lệnh HCN là được 1 hình chữ nhật vát mép 4 góc. Điều này có thể thực hiện được ko. Nếu được nhờ anh em giúp hộ cái.

Chào anh duy782006
Vát mép góc hình chữ nhật khác với bo tròn góc hình chữ nhật
Vát mép góc hình chữ nhật thì sử dụng lệnh Chamfer
bo tròn góc hình chữ nhật thì mới sử dụng lệnh Fillet
Anh xem lại chổ này chút nhé.

Ta có thể vẽ hình chữ nhật và vát mép góc hình chữ nhật chỉ trong một lệnh rec
Command: rec RECTANG
Current rectangle modes: Chamfer=3040.8207 x 3630.0697

Specify first corner point or [Chamfer/Elevation/Fillet/Thickness/Width]:
  • 1

#7 duy782006

duy782006

    PHẠM QUỐC DUY

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 2155 Bài viết
Điểm đánh giá: 1360 (rất tốt)

Đã gửi 09 July 2009 - 08:18 AM

Chào anh duy782006
Vát mép góc hình chữ nhật khác với bo tròn góc hình chữ nhật

À đúng là xấu hổ thật mình ít dùng vát góc nên nghe lại cứ nghỉ tới chuyện bo tròn.

Đây là mình vd TH điển hình nếu la nhiều góc do các line tao thành thì sao?
Đây là đoạn mã vẽ 1 góc được tạo thành bởi 2 dường line mình muốn lập trình vát mép góc này thì phải làm sao?

Lệnh là LF.
Thực chất đây là vẽ đường pline và dùng chức năng fillet tham số P sau khi kết thúc lệnh thì dùng lệnh explode để phá ra thành các đối tượng rời.
Vì bạn chỉ hỏi cách làm nên mình đưa ra giải pháp chính còn các chi tiết như lưu bán kính, trả lại bán kính cũ cho lệnh fillet, lưu, tắt và trả lại chế độ bắt điểm thì bạn tự nghiên cứu và thêm vào nhé.

(DEFUN c:lf ( )
(setq BK (getstring "\nBan kinh bo goc : "))
(setq a (getpoint "\nChon diem dau tien: "))
(setq b (getpoint a"\nChon diem tiep theo: "))
(command "pline" a b "")
(setq plhoinay (entlast))
(setq diemdong a)
(setq a b)
(while (setq b (getpoint a"\nChon diem tiep theo : "))
(command "pline" a b "")
(command "pedit" "m" "L" plhoinay "" "j" "0" "")
(command "fillet" "radius" BK)
(command "fillet" "polyline" "last" "")
(setq plhoinay (entlast))
(setq a b)
)
(command ".EXPLODE" "last")
(princ))


Như đã nói ở trên mình lầm giữa Chamfer và Fillet nên bạn tự chỉnh lại đạon trên nhé.
  • 1

Cứ ngỡ trần gian là cõi thật.Cho nên tất bật đến bây giờ.
Tạo hộp thoại bằng lisp My blog QUY ĐỊNH ĐẶT TÊN TOPIC TRONG CHUYÊN MỤC LISPD http://ktsduy.wordpress.com/
Để cám ơn chỉ cần nhấn rep_up.png
(Là nhấn vào nút đó phía bài viết của người ta í chứ đừng có nhè cái hình này mà nhấn miết đi nha :-D


#8 gia_bach

gia_bach

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 1431 Bài viết
Điểm đánh giá: 1425 (rất tốt)

Đã gửi 09 July 2009 - 10:15 AM

.............................
Ta có thể vẽ hình chữ nhật và vát mép góc hình chữ nhật chỉ trong một lệnh rec
Command: rec RECTANG
Current rectangle modes: Chamfer=3040.8207 x 3630.0697

Specify first corner point or [Chamfer/Elevation/Fillet/Thickness/Width]:

Lisp Hình chử nhật theo gợi ý của bạn Tue_NV
(defun c:HCN (/ os r p1 p2)
(setq os (getvar "OSMODE"))
(setvar "OSMODE" 33)
(setq r (getreal "\nNhap chieu dai vat : "))
(setq p1 (getpoint "\nChon diem dau : "))
(setq p2 (getpoint p1 "\nChon diem tiep : "))
(setvar "OSMODE" 0)
(command "rectang" "c" r r p1 p2 )
(setvar "OSMODE" os)
(princ)
)

  • 1

#9 duy782006

duy782006

    PHẠM QUỐC DUY

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 2155 Bài viết
Điểm đánh giá: 1360 (rất tốt)

Đã gửi 09 July 2009 - 10:43 AM

Lisp Hình chử nhật theo gợi ý của bạn Tue_NV

Như mình đã nói cách này sẽ ảnh hưởng tới lệnh rec sau khi thực hiện lisp. Dùng fillet thì lưu và trả bán kính được. Mình nhớ đã có bạn hỏi về biến lưu giữ giá trị bán kính khi dùng lệnh rec nhưng không nthấy ai tìm ra cả. Có bạn nào biết biến này không làm ơn cho xin.
  • 0

Cứ ngỡ trần gian là cõi thật.Cho nên tất bật đến bây giờ.
Tạo hộp thoại bằng lisp My blog QUY ĐỊNH ĐẶT TÊN TOPIC TRONG CHUYÊN MỤC LISPD http://ktsduy.wordpress.com/
Để cám ơn chỉ cần nhấn rep_up.png
(Là nhấn vào nút đó phía bài viết của người ta í chứ đừng có nhè cái hình này mà nhấn miết đi nha :-D


#10 gia_bach

gia_bach

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 1431 Bài viết
Điểm đánh giá: 1425 (rất tốt)

Đã gửi 09 July 2009 - 02:53 PM

Lisp Hình chử nhật theo gợi ý của bạn Tue_NV

->to duy782006 :
thử tìm kiếm biến lưu giữ giá trị bán kính khi dùng lệnh rec nhưng không thấy đuợc thông tin gì ! <_<
Update Lisp Hình chử nhật
(defun c:HCN (/ os len p1 p2 oo tmp bl br tl tr lst)
(defun makeLWPolyline(lst-pt)
(entmakex
(apply
(function append)
(cons
(list
'(0 . "LWPOLYLINE")
'(100 . "AcDbEntity")
'(100 . "AcDbPolyline")
(cons 90 (length lst-pt))
'(70 . 1)
)
(mapcar
(function list)
(mapcar (function (lambda (a) (cons 10 a))) lst-pt)
) ;_ mapcar
) ;_ cons
) ;_ apply
)
)

(setq os (getvar "OSMODE"))
(setvar "OSMODE" 33)
(or *len* (setq *len* (getvar "chamfera")))
(initget 4)
(setq len (getreal (strcat"\nNhap chieu dai vat <" (rtos *len*) ">:")))
(if len (setq *len* len) (setq len *len*))
(setq p1 (getpoint "\nChon diem dau : ")
p2 (getpoint p1 "\nChon diem tiep : ")
oo (mapcar '/ (mapcar '+ p1 p2) '(2.0 2.0 2.0)); midpoint
tmp (list p1 (list (car p1)(cadr p2)'0 ) p2 (list (car p2)(cadr p1) '0) )
tmp (vl-sort tmp (function (lambda (a :blink:(:s_big:))) )
)
(if
(and
(< (* len 2) (abs (- (car p1) (car p2))))
(< (* len 2) (abs (- (cadr p1) (cadr p2))))
)
(setq tr (nth 0 tmp)
tl (nth 1 tmp)
bl (nth 2 tmp)
br (nth 3 tmp)
lst (list (polar bl (/ pi 2) len)
(polar bl 0 len)
(polar br pi len)
(polar br (/ pi 2) len)
(polar tr (/ pi -2) len)
(polar tr pi len)
(polar tl 0 len)
(polar tl (/ pi -2) len)
)
)
(setq lst tmp)
)
(setvar "OSMODE" 0)
(makeLWPolyline lst)
(setvar "OSMODE" os)
(princ)
)

  • 0